VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "COMDLG32.OCX"
Begin VB.Form frmMain 
   BackColor       =   &H00C0C0C0&
   BorderStyle     =   1  'Fixed Single
   Caption         =   "MV-500 Sample for Windows 95 (VB Version)"
   ClientHeight    =   7185
   ClientLeft      =   6030
   ClientTop       =   4275
   ClientWidth     =   9585
   BeginProperty Font 
      Name            =   "Times New Roman"
      Size            =   36
      Charset         =   0
      Weight          =   700
      Underline       =   0   'False
      Italic          =   -1  'True
      Strikethrough   =   0   'False
   EndProperty
   ForeColor       =   &H000000FF&
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   PaletteMode     =   1  'UseZOrder
   Picture         =   "Main.frx":0000
   ScaleHeight     =   7185
   ScaleWidth      =   9585
   Begin VB.Timer Timer2 
      Enabled         =   0   'False
      Interval        =   10
      Left            =   0
      Top             =   1200
   End
   Begin VB.PictureBox picOverlay 
      Appearance      =   0  'Flat
      BackColor       =   &H00FF00FF&
      BorderStyle     =   0  'None
      ForeColor       =   &H80000008&
      Height          =   7200
      Left            =   0
      ScaleHeight     =   7200
      ScaleWidth      =   9735
      TabIndex        =   0
      Top             =   0
      Visible         =   0   'False
      Width           =   9735
      Begin VB.PictureBox picBall 
         Appearance      =   0  'Flat
         BackColor       =   &H00FF00FF&
         BorderStyle     =   0  'None
         ForeColor       =   &H80000008&
         Height          =   1245
         Left            =   4605
         ScaleHeight     =   1245
         ScaleWidth      =   1305
         TabIndex        =   2
         Top             =   3045
         Width           =   1305
         Begin VB.Shape shpBall 
            BorderColor     =   &H0000FF00&
            Height          =   1215
            Left            =   0
            Shape           =   2  'Oval
            Top             =   0
            Width           =   1260
         End
      End
      Begin VB.Label lblTitle 
         Alignment       =   2  'Center
         Appearance      =   0  'Flat
         BackColor       =   &H00C0C0C0&
         BackStyle       =   0  'Transparent
         Caption         =   "MV-500 Color Key Overlay Demo"
         BeginProperty Font 
            Name            =   "Times New Roman"
            Size            =   24
            Charset         =   0
            Weight          =   700
            Underline       =   0   'False
            Italic          =   -1  'True
            Strikethrough   =   0   'False
         EndProperty
         ForeColor       =   &H000000FF&
         Height          =   615
         Left            =   240
         TabIndex        =   1
         Top             =   240
         Width           =   9105
      End
      Begin VB.Shape shpFrame 
         BorderColor     =   &H00FF0000&
         BorderWidth     =   2
         Height          =   5295
         Left            =   840
         Top             =   1200
         Width           =   7815
      End
   End
   Begin VB.Timer Timer1 
      Enabled         =   0   'False
      Interval        =   100
      Left            =   0
      Top             =   0
   End
   Begin MSComDlg.CommonDialog CommonDialog1 
      Left            =   0
      Top             =   600
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.Line Line1 
      BorderColor     =   &H00FFFFFF&
      Index           =   1
      X1              =   0
      X2              =   9600
      Y1              =   15
      Y2              =   15
   End
   Begin VB.Line Line1 
      BorderColor     =   &H00808080&
      Index           =   0
      X1              =   0
      X2              =   9600
      Y1              =   0
      Y2              =   0
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuExit 
         Caption         =   "&Exit"
      End
   End
   Begin VB.Menu mnuGrab 
      Caption         =   "&Grab"
      Begin VB.Menu mnuStartGrab 
         Caption         =   "&Start Grab"
      End
      Begin VB.Menu mnuFreeze 
         Caption         =   "&Freeze"
      End
      Begin VB.Menu sep2 
         Caption         =   "-"
      End
      Begin VB.Menu mnuOverlayDemo 
         Caption         =   "&Overlay Demo."
      End
   End
   Begin VB.Menu mnuSnap 
      Caption         =   "&Snap"
      Enabled         =   0   'False
   End
   Begin VB.Menu mnuHelp 
      Caption         =   "&Help"
      Begin VB.Menu mnuAboutDemo 
         Caption         =   "&About MV-500 Sample..."
      End
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False


Option Explicit

Dim R As Integer
Dim G As Integer
Dim b As Integer
Dim Grabmode As Integer
Dim WinSizeChanged As Boolean
Dim OldPositionX As Integer
Dim OldPositionY As Integer
Dim Beginning As Boolean


Private Sub commondialog1_Click()

End Sub


Private Sub Form_Load()

'mutex = False

'CamCurrent.dx = 400
'CamCurrent.dy = 300
CamCurrent.dx = 640
CamCurrent.dy = 480

memsize = CamCurrent.dx * CamCurrent.dy * 2
stride = CamCurrent.dx

Me.top = (Screen.height - Me.height) / 2
Me.left = (Screen.width - Me.width) / 2

Beginning = True
OldPositionX = Me.left
OldPositionY = Me.top
    If GrabFlag Then
        Ret_Err (MV5StopGrab(Nothing, Nothing))
           End If
If Load2 = True Then
'    Ret_Err (MV5Close())
    End
Else
    Load2 = True
End If

GrabFlag = False

SDKVersion = MV5InquireSDKVersion()
Ret_Err (MV5Open(SDKVersion))
Ret_Err (MV5LoadDefault(MV5_VideoStandard_NTSC))
Ret_Err (MV5SetVideoChannel(MV5_Channel_Blue))

bvar = False

result = MTDDraw_Open(hWnd, bvar)
If result = MV5_OK Then
    m_ScreenSize = MTDDraw_GetScreenSize()
    m_nScreenMode = MTDDraw_GetScreenMode()
    
    Select Case m_nScreenMode
    
    Case MV5_8bit_Mode
        MsgBox ("This program does not support 256 color or lower!")
        End
        
    Case MV5_RGB888_Mode
    Case MV5_RGB888x_Mode
    Case MV5_RGB555_Mode
    Case MV5_RGB565_Mode
    
    Case Else
        MsgBox ("This program does not support the current screen mode!")
        End
    End Select
    
    If (MTDDraw_IsOverlaySupported()) Then
        result = MTDDraw_CreateOverlayYUV(1, CamCurrent.dx, CamCurrent.dy, 0, m_nSurfaceIndex)
        If result <> MV5_OK Then
            MsgBox ("Can't open overlay surface!")
            End
        Else
'            Ret_Err (MTDDraw_GetOverlayStretchRange(nMinStretch, nMaxStretch))
            m_lpOverlaySurfacePtr = MTDDraw_GetSurfaceMemoryPtr(m_nSurfaceIndex, m_nSurfaceStride)
            dwColorKey = 16711935
            MTDDraw_SetDestColorKey (dwColorKey)
        End If

    Else
        MsgBox ("No overlay surface.")
        End
    End If
Else
    MsgBox ("No DirectDraw!")
    End
End If

Call DefaultWinSize
mnuFreeze.Enabled = False
R = 255: G = 0: b = 255
Grabmode = MV5_Grab_Odd

'''''''''''''''''''''''''''''''''''
'   Overlay image
'''''''''''''''''''''''''''''''''''
PicOverlayTop = picOverlay.top
PicOverlayleft = picOverlay.left
PicOverlayWidth = picOverlay.width
PicOverlayHeight = picOverlay.height
ShpFrameTop = shpFrame.top
ShpFrameleft = shpFrame.left
ShpFrameWidth = shpFrame.width
ShpFrameHeight = shpFrame.height
PicBallTop = picBall.top
PicBallLeft = picBall.left
PicBallWidth = picBall.width
PicBallHeight = picBall.height
LblTitleTop = lblTitle.top
LblTitleLeft = lblTitle.left
LblTitleWidth = lblTitle.width
LblTitleHeight = lblTitle.height
LblTitleFontSize = lblTitle.FontSize
ShpBallWidth = shpBall.width
ShpBallHeight = shpBall.height
dx = step
dy = step

End Sub

Private Sub Ret_Err(ret As Long)
If (ret = MV5_OK) Then Exit Sub
If (ret = MV5_ERROR) Then MsgBox ("MV5_ERROR")
If (ret = MV5_PARAM_ERR) Then MsgBox ("MV5_PARAM_ERR")
If (ret = MV5_OPEN_ERR) Then MsgBox ("MV5_OPEN_ERR")
If (ret = MV5_COMPATIBLE_ERR) Then MsgBox ("MV5_COMPATIBLE_ERR")
If (ret = MV5_HARDWARE_ERR) Then MsgBox ("MV5_HARDWARE_ERR")
If (ret = MV5_MEM_ALLOC_ERR) Then MsgBox ("MV5_MEM_ALLOC_ERR")
If (ret = MV5_NOT_INIT) Then MsgBox ("MV5_NOT_INIT")
If (ret = MV5_FILE_NOT_EXIST) Then MsgBox ("MV5_FILE_NOT_EXIST")
If (ret = MV5_FILE_FORMAT_ERR) Then MsgBox ("MV5_FILE_FORMAT_ERR")
If (ret = MV5_TOO_MANY_CALLBACK) Then MsgBox ("MV5_TOO_MANY_CALLBACK")
If (ret = MV5_MEM_TOO_BIG) Then MsgBox ("MV5_MEM_TOO_BIG")
If (ret = MV5_STILL_GRAB) Then MsgBox ("MV5_STILL_GRAB")
If (ret = MV5_NOT_GRAB) Then MsgBox ("MV5_NOT_GRAB")
If (ret = MV5_NOT_SUPPORTED) Then MsgBox ("MV5_NOT_SUPPORTED")
End Sub

Private Sub Form_Paint()
   '
   ' Put text on form
   '
If Beginning Then
   Me.ForeColor = &HFF0000
   Me.CurrentX = (Me.ScaleWidth / 2) - (Me.TextWidth("Welcome to") / 2)
   Me.CurrentY = Me.TextHeight("Welcome to") + 800
   Me.Print "Welcome to"
   Me.CurrentX = (Me.ScaleWidth / 2) - (Me.TextWidth("Tech World") / 2)
   Me.CurrentY = Me.CurrentY + 400
   Me.Print "Tech World"
   Beginning = False
End If

End Sub

Private Sub Form_Resize()
    Me.Refresh
End Sub

Private Sub Form_Terminate()
'This is from the window close box
    If GrabFlag Then
        Ret_Err (MV5StopGrab(Nothing, Nothing))
           End If
    Ret_Err (MV5Close)
    MTDDraw_DestroyOverlayYUV (m_nSurfaceIndex)
    Ret_Err (MTDDraw_Close)
    End
End Sub



Private Sub mnu_Pic_Click()

End Sub

Private Sub mnuAboutDemo_Click()
    frmAbout.Show 1
End Sub

Private Sub mnuExit_Click()
'this is from file/exit
    If GrabFlag Then
        Ret_Err (MV5StopGrab(Nothing, Nothing))
           End If
    Ret_Err (MV5Close)
    MTDDraw_DestroyOverlayYUV (m_nSurfaceIndex)
    Ret_Err (MTDDraw_Close)
    End
End Sub


Private Sub mnuFreeze_Click()
    Ret_Err (MV5StopGrab(Nothing, Nothing))
    GrabFlag = False
    mnuStartGrab.Enabled = True
    mnuFreeze.Enabled = False
    mnuSnap.Enabled = True
End Sub

Private Sub mnuLoad_Click()
End Sub


Private Sub mnuOverlayDemo_Click()
If mnuOverlayDemo.Checked Then
    mnuOverlayDemo.Checked = False
    picOverlay.Visible = False
Else
    mnuOverlayDemo.Checked = True
    Call ShowOverlay
    Call MoveBall
End If
End Sub

Private Sub mnuSave_Click()
Dim fname As String
On Error GoTo ErrHandler
If GrabFlag Then
    Ret_Err (MV5StopGrab(Nothing, Nothing))
    GrabFlag = False
    mnuStartGrab.Enabled = True
End If
fname = ""
CommonDialog1.Filter = "BMP Files(*.bmp)|*.bmp|Tga Files(*.tga)|*.tga|Tiff Files(*.tif)|*.tif|All Files (*.*)|*.*"
'Specify default filterIndex.
CommonDialog1.FilterIndex = 1
'Display the Open dialog box.
CommonDialog1.ShowSave
fname = CommonDialog1.filename
If fname = "" Then
    Exit Sub
End If
Exit Sub
ErrHandler:
    Exit Sub
End Sub
Private Sub mnuSnap_Click()

Dim retCode As Integer

'If mutex = True Then Exit Sub
'mutex = True

Ret_Err (MV5SetPixelMode(MV5_YUV422_Mode))
Ret_Err (MV5SetGrabWindow(0, 0, CamCurrent.dx, CamCurrent.dy, MyFrame))
Ret_Err (MV5SetMasterModeTransferMemory(MyFrame, MYbuffer(1, 1), CamCurrent.dx * CamCurrent.dy * 2, m_nSurfaceStride / 2))
Ret_Err (MV5SetStrobe(1))
Ret_Err (MV5StartGrab(MV5_Single_Grab, MV5_Grab_Odd))
Ret_Err (MV5SetStrobe(0))

Timer1.Enabled = True
Ret_Err (MV5Memory2BMPfile("test.bmp", 0, 0, CamCurrent.dx, CamCurrent.dy, CamCurrent.dx, MV5_YUV422_Mode, MYbuffer(1, 1)))


'=========================================================================

Exit Sub


Ret_Err (MV5Memory2BMPfile("test.bmp", 0, 0, CamCurrent.dx, CamCurrent.dy, CamCurrent.dx, MV5_YUV422_Mode, MYbuffer(1, 1)))

'Formimage.Picture1 = LoadPicture("test.bmp")
'Formimage.Show 0

'mutex = False

End Sub

Private Sub mnuStartGrab_Click()
    
    ImgDxOld = ImgDx
    ImgDyOld = ImgDy
    ImgDx = MV5_NTSC_Width_Default
    ImgDy = MV5_NTSC_Height_Default
    WinSizeChanged = ImgDx <> ImgDxOld Or ImgDy <> ImgDyOld
    If WinSizeChanged Then
        Call DefaultWinSize
    End If
    Timer1.Enabled = False  ' Stop "Welcome" Window
  Ret_Err (MV5SetPixelMode(MV5_YUV422_Mode))
Ret_Err (MV5SetGrabWindow(0, 0, CamCurrent.dx, CamCurrent.dy, MyFrame))
Ret_Err (MV5SetMasterModeTransfer(MyFrame, m_lpOverlaySurfacePtr, CamCurrent.dx * CamCurrent.dy * 2, CamCurrent.dx))
Ret_Err (MV5StartGrab(MV5_Cont_Grab, MV5_Grab_Odd))
         srect.left = 0
        srect.top = 0
        srect.right = CamCurrent.dx - 1
        srect.bottom = CamCurrent.dy - 1

       Ret_Err (GetWindowRect(hWnd, drect))

        Ret_Err (MTDDraw_MapSurfaceRect(m_nSurfaceIndex, drect, srect, True))

 
    GrabFlag = True
    mnuOverlayDemo.Enabled = True
    mnuStartGrab.Enabled = False
    mnuFreeze.Enabled = True
    mnuSnap.Enabled = False
    frmMain.BackColor = &HFF00FF
    If mnuOverlayDemo.Checked And WinSizeChanged Then
        Call ShowOverlay
        Call MoveBall
    End If
End Sub



Private Sub Msghook1_Message(ByVal msg As Long, ByVal wp As Long, ByVal lp As Long, result As Long)
If msg = WM_WINDOWPOSCHANGING Then
End If
End Sub



Public Sub ShowOverlay()
Dim WidthRate As Single
Dim HeightRate As Single

WidthRate = ImgDx / MV5_NTSC_Width_Default
HeightRate = ImgDy / MV5_NTSC_Height_Default
picOverlay.top = PicOverlayTop
picOverlay.left = PicOverlayleft
picOverlay.width = PicOverlayWidth * WidthRate
picOverlay.height = PicOverlayHeight * HeightRate
shpFrame.top = ShpFrameTop * HeightRate
shpFrame.left = ShpFrameleft * WidthRate
shpFrame.width = ShpFrameWidth * WidthRate
shpFrame.height = ShpFrameHeight * HeightRate
picBall.top = PicBallTop * HeightRate
picBall.left = PicBallLeft * WidthRate
picBall.width = PicBallWidth * WidthRate
picBall.height = PicBallHeight * WidthRate
lblTitle.top = LblTitleTop * HeightRate
lblTitle.left = LblTitleLeft * WidthRate
lblTitle.width = LblTitleWidth * WidthRate
lblTitle.height = LblTitleHeight * HeightRate
lblTitle.FontSize = LblTitleFontSize * WidthRate
shpBall.width = ShpBallWidth * WidthRate
shpBall.height = ShpBallHeight * WidthRate
picOverlay.Visible = True
End Sub

Public Sub MoveBall()

UpCurrent = shpFrame.top + 15
DownCurrent = shpFrame.top + shpFrame.height - picBall.height - 15 * shpFrame.BorderWidth
LeftCurrent = shpFrame.left + 15
RightCurrent = shpFrame.left + shpFrame.width - picBall.width - 15 * shpFrame.BorderWidth
Do While 1 = 1
    problem = DoEvents()

    If ExitFlag = True Then Exit Do
    picBall.left = picBall.left + dx
    picBall.top = picBall.top + dy
    If picBall.left >= RightCurrent Then
        dx = -dx
    ElseIf picBall.top >= DownCurrent Then
        dy = -dy
    ElseIf picBall.left <= LeftCurrent Then
        dx = -dx
    ElseIf picBall.top <= UpCurrent Then
        dy = -dy
    End If
    For i = 1 To 2999
    Next i
Loop
End Sub



Public Sub DefaultWinSize()
    frmMain.width = MV5_NTSC_Width_Default * 15
    frmMain.height = MV5_NTSC_Height_Default * 15 + 600
    GrabWndWidth = MV5_NTSC_Width_Default
    GrabWndHeight = MV5_NTSC_Height_Default
End Sub

Public Sub GrabImage()
End Sub

Private Sub Timer1_Timer()
 '   mutex = False
    Timer1.Enabled = False
    
    Ret_Err (MV5Memory2BMPfile("test.bmp", 0, 0, CamCurrent.dx, CamCurrent.dy, CamCurrent.dx, MV5_YUV422_Mode, MYbuffer(1, 1)))

'    Formimage.Picture1 = LoadPicture("test.bmp")
'    Formimage.Show 0

End Sub

Private Sub Timer2_Timer()
If Me.top <> OldPositionY Or Me.left <> OldPositionX Then
    OldPositionX = Me.left
    OldPositionY = Me.top
End If
End Sub


